`timescale 1ns / 1ps

module solvemanager(
input Clk,
input Reset,
input [127:0]inputhash,

output reg solvedone,
output reg [63:0]solvedword,
output reg [127:0]attempts
);


//reg Clk = 0;
//always #5 Clk = ~Clk;
//reg Reset = 0;
//reg [127:0]inputhash=128'h0cc175b9c0f1b6a831c399e269772661;
//
//initial begin
//		Reset = 1;
//		
//		#20
//		Reset = 0;
//		
//		/*#25000
//		Reset = 1;
//		inputhash=128'h4124bc0a9335c27f086f24ba207a4912;
//		#10
//		Reset = 0;*/
//end

reg [63:0]currentword;
reg failedflag = 0;

//reg [3:0]wordlen;
//ASCII 32 - 126
//Divide into 8 sections
//|a | | | | | | | |
//| a|a | | | | | | |
integer i;
integer j;
integer k;
parameter n=1;
reg [63:0] wordinput[n-1:0];
reg [3:0] wordlength[n-1:0];

always @(posedge Clk)begin
	if(Reset==1)begin
		for(j=0;j<n;j=j+1)begin
			solvedone<=0;
			wordinput[j]<=0;
			wordinput[j][63:56]<=8'd32+j;
			wordlength[j]<=0;
			attempts<=n;
		end	
	end
	if(Reset==0) begin
	
	if ((solvedone == 0)||(failedflag==0)) begin
	attempts<=attempts+n;		
	for (i = 0; i<n ; i=i+1) begin
			if (solvedflag[i]==1) begin
				solvedone<=1'b1;
				solvedword<=wordout[i];
			end
	end
	
		for(j=0;j<n;j=j+1) begin
			k=wordlength[j]-1;
			if((wordlength[j]==0)&&(wordinput[j][(56-wordlength[j]*8)+:8]+n)>=127)begin
				wordinput[j][(56-(wordlength[j]+1)*8)+:8]<=8'd32+(wordinput[j][(56-(wordlength[j])*8)+:8]+n-127);
				wordinput[j][63:56]<=8'd32;
				wordlength[j]<=wordlength[j]+1;
			end
			else if((wordinput[j][(56-wordlength[j]*8)+:8]+n)>=127) begin
				wordinput[j][(56-wordlength[j]*8)+:8]<=8'd32+(wordinput[j][(56-(wordlength[j])*8)+:8]+n-127);
				for(i=0;i<8;i=i+1)begin
					if(k>=0)begin
						if((k==0)&&((wordinput[j][56-0*8+:8]+1)==127))begin
							wordlength[j]<=wordlength[j]+1;
							wordinput[j]<=wordinput[j]>>8;
							wordinput[j][63:56]<=8'd32;
							k=k-1;
						end
						else begin
							if((wordinput[j][56-(k)*8+:8]+1)==127)begin
								wordinput[j][56-(k)*8+:8]<=8'd32;
								k=k-1;
							end
							else begin
								wordinput[j][56-(k)*8+:8]<=wordinput[j][56-(k)*8+:8]+1;
								k=-1;
							end
						end
					end
					else begin
					
					end
				end
			end
			else begin
				wordinput[j][(56-(wordlength[j])*8)+:8]<=(wordinput[j][(56-(wordlength[j])*8)+:8]+n);
			end
		end
	end
end
end

reg startflag=1'b1;
wire [n-1:0]solvedflag;
wire [127:0]hashout [n-1:0];
wire [63:0]wordout [n-1:0];
wire validtest [n-1:0];

//reg [63:0]solveword[n-1:0];

genvar index;  
generate  
for (index=0; index < n; index=index+1)  
  begin: gen_code_label  

	solver solver_inst(
	 Clk,
	 Reset,
	 inputhash,
    wordinput[index],
    wordlength[index],

    solvedflag[index],
	 hashout[index],
	 wordout[index],
	 validtest[index]
		);
  end  
endgenerate  

endmodule
